// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Light abstract class. The base class for all the lights.

package vlc.vrml.external.geometry;

import vrml.external.*;
import vrml.external.field.*;

public abstract class Light extends ChildrenNode
{
	protected EventInSFFloat	_set_ambientIntensity;
	protected EventInSFColor	_set_color;
	protected EventInSFFloat	_set_intensity;
	protected EventInSFBool		_set_on;

	protected float		_ambientIntensity = 0;
	protected float[]	_color = { 1, 1, 1 };
	protected float		_intensity = 1;
	protected boolean	_on = true;

	protected Light()
	{
	}

	public void set_ambientIntensity(float val)
	{
		_ambientIntensity = val;
		if(have_browser)
			_set_ambientIntensity.setValue(val);
	}

	public float get_ambientIntensity()
	{
		return(_ambientIntensity);
	}

	public void set_color(float[] val)
	{
		_color = val;
		if(have_browser)
			_set_color.setValue(val);
	}

	public float[] get_color()
	{
		return(_color);
	}

	public void set_intensity(float val)
	{
		_intensity = val;
		if(have_browser)
			_set_intensity.setValue(val);
	}

	public float get_intensity()
	{
		return(_intensity);
	}

	public void set_on(boolean val)
	{
		_on = val;
		if(have_browser)
			_set_on.setValue(val);
	}

	public boolean get_on()
	{
		return(_on);
	}
}