// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// TouchSensor class

package vlc.vrml.external.geometry;

import java.io.*;
import vrml.external.*;
import vrml.external.field.*;

public class TouchSensor extends Sensor
{
	private EventOutSFVec3f	_get_hitNormal_changed;
	private EventOutSFVec3f	_get_hitPoint_changed;
	private EventOutSFVec2f	_get_hitTexCoord_changed;
	private EventOutSFBool	_get_isOver;
	private EventOutSFTime	_get_touchTime;

	public TouchSensor()
	{
		Browser b = Browser.getBrowser();

		if(b == null)
			return;

		node = b.createVrmlFromString("TouchSensor {}")[0];

		createFields();
	}

	public TouchSensor(Browser b)
	{
		if(b == null)
			return;

		node = b.createVrmlFromString("TouchSensor {}")[0];

		createFields();
	}

	private void createFields()
	{
		_set_enabled = (EventInSFBool)node.getEventIn("enabled");

		_get_isActive = (EventOutSFBool)node.getEventOut("isActive");
		_get_hitNormal_changed = (EventOutSFVec3f)node.getEventOut("hitNormal_changed");
		_get_hitPoint_changed = (EventOutSFVec3f)node.getEventOut("hitPoint_changed");
		_get_hitTexCoord_changed = (EventOutSFVec2f)node.getEventOut("hitTexCoord_changed");
		_get_isOver = (EventOutSFBool)node.getEventOut("isOver");
		_get_touchTime = (EventOutSFTime)node.getEventOut("touchTime");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.TouchSensor;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int	i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println(buffer.toString() + "TouchSensor {");

		if(!_enabled)
			fp.println(buffer.toString() + "  enabled FALSE");

		fp.println(buffer.toString() + "}");
	}

	public float[] get_hitNormal_changed()
	{
		return(_get_hitNormal_changed.getValue());
	}

	public float[] get_hitPoint_changed()
	{
		return(_get_hitPoint_changed.getValue());
	}

	public float[] get_hitTexCoord_changed()
	{
		return(_get_hitTexCoord_changed.getValue());
	}

	public boolean get_isOver()
	{
		return(_get_isOver.getValue());
	}

	public double get_touchTime()
	{
		return(_get_touchTime.getValue());
	}
}