// VRML Generator
// Copyright Justin Couch 1996
//
// From Chapter 25 Late Night VRML 2.0 and Java
//
// VRML base object definition
// There are three main peices of information. The name is the DEF name
// associated with this object. The Node is the information returned from
// the createVrmlFromString call. And the Type is the type represented
// as an integer from the VrmlTypes.java.

package vlc.vrml.external.geometry;

import java.io.PrintStream;
import vrml.external.Node;

public abstract class VrmlObject implements Cloneable
{
	protected boolean	have_browser = false;
	protected int		type = -1;

	public String	name = null;
	public Node		node = null;

	// called just before a node is to be deleted by its parent. A blank
	// version is provided for nodes that don't need to do anything
	public void cleanup()
	{
	}

	public abstract void writeToFile(PrintStream fp, int indent);

	public String toString()
	{
		return(name);
	}

	public int get_nodeType()
	{
		return(type);
	}
}

