// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Color class.

package vlc.vrml.internal.geometry;

import java.io.PrintStream;
import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class Color extends VrmlObject
{
	private MFColor _set_color;

	private float[][] _color;

	public Color(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("Color {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		createFields();
	}

	private void createFields()
	{
		_set_color = (MFColor)node.getEventIn("color");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.Color;
	}

	public void cleanup()
	{
		_color = null;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int     i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "color ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println("Color {");

		if(_color.length > 0)
		{
			fp.print(buffer.toString() + "  color ");

			if(_color.length == 1)
				fp.println(_color[0]);
			else
			{
				fp.println("[");

				for(i = 0; i < _color.length; i++)
					fp.println(buffer.toString() + "  " + _color[i]);

				fp.println(buffer.toString() + "  ]");
			}
		}
		fp.println(buffer.toString() + "}");
	}

	public void set_color(float[][] color)
	{
		_color = color;
		if(have_browser)
			_set_color.setValue(color);
	}
	
	public float[][] get_color()
	{
		return(_color);
	}
}
