// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// NormalInterpolator class

package vlc.vrml.internal.geometry;

import java.io.*;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class OrientationInterpolator extends Interpolator
{
	private MFRotation	_set_keyValue;
	private ConstSFRotation	_get_value_changed;

	private float[][]	_keyValue;

	public OrientationInterpolator(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("OrientationInterpolator {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		createFields();
	}

	private void createFields()
	{
		_set_keyValue = (MFRotation)node.getEventIn("keyValue");

		_get_value_changed = (ConstSFRotation)node.getEventOut("value_changed");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.OrientationInterpolator;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int	i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println(buffer.toString() + "OrientationInterpolator {");

		if(_key != null)
		{
			fp.println(buffer.toString() + "  key [");

			for(i = 0; i < _key.length; i++)
				fp.println(buffer.toString() + "    " + _key[i]);

			fp.println(buffer.toString() + "  ]");
		}

		if(_keyValue != null)
		{
			fp.println(buffer.toString() + "  keyValue [");

			// now print the keyValues, 1 per line
			for(i = 0; i < _keyValue.length; i++)
				fp.println(buffer.toString() + "    " +
						   _keyValue[i][0] + " " +
						   _keyValue[i][1] + " " +
						   _keyValue[i][2] + " " +
						   _keyValue[i][3]);

			fp.println(buffer.toString() + "  ]");
		}

		fp.println(buffer.toString() + "}");
	}
	
	public void set_keyValue(float[][] orientations)
	{
		_keyValue = orientations;
		if(have_browser)
			_set_keyValue.setValue(_keyValue);
	}
	
	public float[][] get_keyValue()
	{
		return(_keyValue);
	}

	public float[] get_value_changed()
	{
		float[] val = null;

		_get_value_changed.getValue(val);

		return(val);
	}
}