// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Box class

package vlc.vrml.internal.geometry;

import java.io.*;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class Sphere extends Geometry
{
	private float _radius = 1;

	public Sphere(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("Sphere {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}
	}

	public Sphere(Browser b, float radius)
	{
		_radius = radius;

		if(b == null)
			return;

		String tmp = "Sphere { radius " + radius + " }";

		try
		{
			node = (Node)b.createVrmlFromString(tmp)[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int	i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "geometry ");
		if(name != null)
			fp.print("DEF " + name + " ");

		fp.print("Sphere {");

		if(_radius != 1)
			fp.print(" radius " + _radius + " ");

		fp.println("}");
	}

	public float get_radius()
	{
		return(_radius);
	}
}
